﻿
// AqTkAppDlg.cpp : 実装ファイル
//

#include "pch.h"
#include "framework.h"
#include "AqTkApp.h"
#include "AqTkAppDlg.h"
#include "afxdialogex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAqTkAppDlg ダイアログ
#define	WM_USR_DADONE	(WM_USER+111)
#define	ID_SHEEP	999		// 羊が一匹、・・・の識別ID




CAqTkAppDlg::CAqTkAppDlg(CWnd* pParent /*=nullptr*/)
	: CDialogEx(IDD_AQTKAPP_DIALOG, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_AquesTalkDa = AquesTalkDa_Create();
}

void CAqTkAppDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAqTkAppDlg, CDialogEx)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_PLAY_COMBO, OnPlayCombo)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_BN_CLICKED(IDC_PLAY_UNIT, OnPlayUnit)
	ON_BN_CLICKED(IDC_PLAY_DATE, OnPlayDate)
	ON_BN_CLICKED(IDC_PLAY_TEXT, OnPlayText)
	ON_BN_CLICKED(IDC_PLAY_TIME, OnPlayTime)
	ON_BN_CLICKED(IDC_PLAY_SHEEP, OnPlaySheep)
	ON_BN_CLICKED(IDC_SAVE, OnSave)
	ON_WM_HSCROLL()
	ON_MESSAGE(WM_USR_DADONE, OnDone)	// 音声合成終了のメッセージ
END_MESSAGE_MAP()


// CAqTkAppDlg メッセージ ハンドラー

BOOL CAqTkAppDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// このダイアログのアイコンを設定します。アプリケーションのメイン ウィンドウがダイアログでない場合、
	//  Framework は、この設定を自動的に行います。
	SetIcon(m_hIcon, TRUE);			// 大きいアイコンの設定
	SetIcon(m_hIcon, FALSE);		// 小さいアイコンの設定

	// TODO: 初期化をここに追加します。
	InitControl();
	m_iSheep = 0;
	m_iSpeed = 100;
	return TRUE;  // フォーカスをコントロールに設定した場合を除き、TRUE を返します。
}

// ダイアログに最小化ボタンを追加する場合、アイコンを描画するための
//  下のコードが必要です。ドキュメント/ビュー モデルを使う MFC アプリケーションの場合、
//  これは、Framework によって自動的に設定されます。

void CAqTkAppDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // 描画のデバイス コンテキスト

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// クライアントの四角形領域内の中央
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// アイコンの描画
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// ユーザーが最小化したウィンドウをドラッグしているときに表示するカーソルを取得するために、
//  システムがこの関数を呼び出します。
HCURSOR CAqTkAppDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

//! 各コントロールの初期化
void CAqTkAppDlg::InitControl()
{
	//固定文
	SendDlgItemMessage(IDC_COMBO, CB_ADDSTRING, 0, (LPARAM)"でんわば'んごーわ、<NUM VAL=01-2345-6789>です。");
	SendDlgItemMessage(IDC_COMBO, CB_ADDSTRING, 0, (LPARAM)"さーばー;<NUM VAL=3512>の/ハードディ'_ス_クに、エ'ラー+はっせー。");
	SendDlgItemMessage(IDC_COMBO, CB_ADDSTRING, 0, (LPARAM)"げつよ'ーの/<NUMK VAL=21 COUNTER=じ>から、<NUMK VAL=8 COUNTER=ちゃ'んねる>で/よやく+しま'した。");
	SendDlgItemMessage(IDC_COMBO, CB_ADDSTRING, 0, (LPARAM)"りょ'ーきんわ;<NUMK VAL=550 COUNTER=えん>です。");
	SendDlgItemMessage(IDC_COMBO, CB_ADDSTRING, 0, (LPARAM)"すみませ'ん、<NUMK VAL=10 COUNTER=ふん>+おくれま'す。");
	SendDlgItemMessage(IDC_COMBO, CB_ADDSTRING, 0, (LPARAM)"<NUMK VAL=7 COUNTER=じ>/<NUMK VAL=20 COUNTER=ふん>に、え'きで/ま'ってます。");
	SendDlgItemMessage(IDC_COMBO, CB_ADDSTRING, 0, (LPARAM)"あすのて'んき、とーきょー、はれ'のち+くもり、さいこーき'おん、<NUMK VAL=25 COUNTER=ど MODE=AaH>。");
	SendDlgItemMessage(IDC_COMBO, CB_ADDSTRING, 0, (LPARAM)"<NUMK VAL=100 COUNTER=め'ーとる>さき、こーえんいりぐちの/こーさてんを+ひだりで'す。");
	SendDlgItemMessage(IDC_COMBO, CB_ADDSTRING, 0, (LPARAM)"このさき;<NUMK VAL=3 COUNTER=きろ>/じゅーたいちゅー。つーかじ'かん;<NUMK VAL=10 COUNTER=ふん>、");
	SendDlgItemMessage(IDC_COMBO, CB_ADDSTRING, 0, (LPARAM)"よろし'いですか？");
	SendDlgItemMessage(IDC_COMBO, CB_ADDSTRING, 0, (LPARAM)"これでい'い？");
	SendDlgItemMessage(IDC_COMBO, CB_ADDSTRING, 0, (LPARAM)"ばってりーの/じゅーでん+かんりょー。");
	SendDlgItemMessage(IDC_COMBO, CB_ADDSTRING, 0, (LPARAM)"<NUMK VAL=2006 COUNTER=ねん>、<NUMK VAL=1 COUNTER=がつ>;<NUMK VAL=15 COUNTER=にち>。");
	SendDlgItemMessage(IDC_COMBO, CB_ADDSTRING, 0, (LPARAM)"<NUMK VAL=16 COUNTER=じ>;<NUMK VAL=5 COUNTER=ふん>/<NUMK VAL=35 COUNTER=びょー>です。");
	SendDlgItemMessage(IDC_COMBO, CB_ADDSTRING, 0, (LPARAM)"それから'わ、やまぐち'けんで;やとわれば'んとーお/するよ'ーに+な'り、か'ぞくの/もと'にわ、ほと'んど;もどれ'なく+なりま'した。");
	SendDlgItemMessage(IDC_COMBO, CB_ADDSTRING, 0, (LPARAM)"ばくおんが、ぎんせ'かいの/こーげんに/ひろがる。");
	SendDlgItemMessage(IDC_COMBO, CB_SETHORIZONTALEXTENT , 1000, 0);
	SendDlgItemMessage(IDC_COMBO, CB_SETCURSEL, 0, 0);

	//助数詞つき
	SendDlgItemMessage(IDC_NUM, WM_SETTEXT, 0, (LPARAM)"123.45");
	SendDlgItemMessage(IDC_UNIT, CB_ADDSTRING, 0, (LPARAM)"年 ねん");
	SendDlgItemMessage(IDC_UNIT, CB_ADDSTRING, 0, (LPARAM)"月 がつ");
	SendDlgItemMessage(IDC_UNIT, CB_ADDSTRING, 0, (LPARAM)"日 にち");
	SendDlgItemMessage(IDC_UNIT, CB_ADDSTRING, 0, (LPARAM)"時 じ");
	SendDlgItemMessage(IDC_UNIT, CB_ADDSTRING, 0, (LPARAM)"分 ふん");
	SendDlgItemMessage(IDC_UNIT, CB_ADDSTRING, 0, (LPARAM)"秒 びょー");
	SendDlgItemMessage(IDC_UNIT, CB_ADDSTRING, 0, (LPARAM)"円 えん");
	SendDlgItemMessage(IDC_UNIT, CB_ADDSTRING, 0, (LPARAM)"回 かい");
	SendDlgItemMessage(IDC_UNIT, CB_ADDSTRING, 0, (LPARAM)"階 か'い");
	SendDlgItemMessage(IDC_UNIT, CB_ADDSTRING, 0, (LPARAM)"ヶ月 か'げつ");
	SendDlgItemMessage(IDC_UNIT, CB_ADDSTRING, 0, (LPARAM)"カロリー か'ろりー");
	SendDlgItemMessage(IDC_UNIT, CB_ADDSTRING, 0, (LPARAM)"級 きゅー");
	SendDlgItemMessage(IDC_UNIT, CB_ADDSTRING, 0, (LPARAM)"行 ぎょー");
	SendDlgItemMessage(IDC_UNIT, CB_ADDSTRING, 0, (LPARAM)"曲 きょく");
	SendDlgItemMessage(IDC_UNIT, CB_ADDSTRING, 0, (LPARAM)"キロ き'ろ");
	SendDlgItemMessage(IDC_UNIT, CB_ADDSTRING, 0, (LPARAM)"件 けん");
	SendDlgItemMessage(IDC_UNIT, CB_ADDSTRING, 0, (LPARAM)"個 こ");
	SendDlgItemMessage(IDC_UNIT, CB_ADDSTRING, 0, (LPARAM)"人 にん");
	SendDlgItemMessage(IDC_UNIT, CB_ADDSTRING, 0, (LPARAM)"才 さい");
	SendDlgItemMessage(IDC_UNIT, CB_ADDSTRING, 0, (LPARAM)"時間 じ'かん");
	SendDlgItemMessage(IDC_UNIT, CB_ADDSTRING, 0, (LPARAM)"台 だい");
	SendDlgItemMessage(IDC_UNIT, CB_ADDSTRING, 0, (LPARAM)"丁目 ちょーめ");
	SendDlgItemMessage(IDC_UNIT, CB_ADDSTRING, 0, (LPARAM)"月（つき） つき");
	SendDlgItemMessage(IDC_UNIT, CB_ADDSTRING, 0, (LPARAM)"番 ばん");
	SendDlgItemMessage(IDC_UNIT, CB_ADDSTRING, 0, (LPARAM)"本 ほん");
	SendDlgItemMessage(IDC_UNIT, CB_ADDSTRING, 0, (LPARAM)"匹 ひき");
	SendDlgItemMessage(IDC_UNIT, CB_ADDSTRING, 0, (LPARAM)"％ ぱーせ'んと");
	SendDlgItemMessage(IDC_UNIT, CB_SETCURSEL, 0, 0);

	//任意文
	SendDlgItemMessage(IDC_TEXT, WM_SETTEXT, 0, (LPARAM)"ここに、しよーに/したがって、おんせー+き'ごーを/いれよ'ー。");

	// スライダーの範囲を50-300とする
	CSliderCtrl *pSlider = (CSliderCtrl*)GetDlgItem(IDC_SPEED);
	pSlider->SetRange(50, 300, FALSE);
	pSlider->SetPos(100);



}

//! ログウィンドウ(最下）に出力
void CAqTkAppDlg::PrintLog(const char *fmt, ...)
{
	// 文字列 format
    char buf[1024];
    va_list args;
    va_start(args, fmt);
    wvsprintf(buf, fmt, args);

	// 文字列の追加
	CEdit *pCtrl = (CEdit*)GetDlgItem(IDC_LOG);
	CString txt;
	pCtrl->GetWindowText(txt);
	txt += buf;
	pCtrl->SetWindowText(txt);
	pCtrl->SetSel(0, -1, FALSE);
    va_end(args);
}

void CAqTkAppDlg::SynthePlay(CString &koe, LPARAM dwUser)
{
	PrintLog("Play(\"%s\")\r\n", koe);
	int iret = AquesTalkDa_Play(m_AquesTalkDa, koe, m_iSpeed, this->m_hWnd, WM_USR_DADONE, dwUser);
	if(iret==0)		PrintLog("=>OK\r\n");
	else			PrintLog("=>ERR:%d\r\n", iret);
}


void CAqTkAppDlg::OnStop() 
{
	PrintLog("Stop\r\n");
	AquesTalkDa_Stop(m_AquesTalkDa);
	m_iSheep=0;
}

//! 発声の終了時に呼ばれるメッセージハンドラ
LRESULT CAqTkAppDlg::OnDone(WPARAM wParam, LPARAM lParam)
{
	PrintLog("Done %d\r\n", lParam);

	// 羊が一匹、・・・の場合は、次の読みあげを実行
	if(ID_SHEEP==lParam && m_iSheep!=0)	PlaySheep();

	return 0;
}


//! 固定文の読み上げ
void CAqTkAppDlg::OnPlayCombo() 
{
	CComboBox *pCtrl = (CComboBox*)GetDlgItem(IDC_COMBO);
	//選択文字列の取得
	int idx = pCtrl->GetCurSel();
	if(idx==CB_ERR)	return;
	CString koe;
	pCtrl->GetLBText(idx, koe);
	if(koe=="") return;

	//音声合成＆再生
	SynthePlay(koe);
}

//! 数値＋単位の読み上げ
void CAqTkAppDlg::OnPlayUnit() 
{
	CString strNum;
	//数値文字列の取得
	((CEdit*)GetDlgItem(IDC_NUM))->GetWindowText(strNum);
	if(strNum=="") return;

	//単位文字列の取得
	CString strUnit;
	CComboBox *pCtrl = ((CComboBox*)GetDlgItem(IDC_UNIT));
	int idx = pCtrl->GetCurSel();
	if(idx<0)	return;
	pCtrl->GetLBText( idx, strUnit);
	if(strUnit=="") return;
	//読み記号部分を抽出
	int i = strUnit.Find(' ');
	strUnit.Delete(0, i+1);	// 最初の空白前を除く

	//音声記号列の構成
	CString koe;
	koe.Format("<NUMK VAL=%s COUNTER=%s>。", strNum, strUnit);

	//音声合成＆再生
	SynthePlay(koe);
}

//! 任意の音声記号列の読み上げ
void CAqTkAppDlg::OnPlayText() 
{
	CString koe;
	//数値文字列の取得
	((CEdit*)GetDlgItem(IDC_TEXT))->GetWindowText(koe);
	if(koe=="") return;

	//音声合成＆再生
	SynthePlay(koe);
}


//! 今日の日付の読み上げ
void CAqTkAppDlg::OnPlayDate() 
{
	CTime theTime = CTime::GetCurrentTime();
	CString koe;
	koe += theTime.Format( "<NUMK VAL=%Y COUNTER=ねん>;" );
	koe += theTime.Format( "<NUMK VAL=%m COUNTER=がつ>;" );
	koe += theTime.Format( "<NUMK VAL=%d COUNTER=にち>デ_ス。" );

	//音声合成＆再生
	SynthePlay(koe);
}

//!現在時刻の読み上げ
void CAqTkAppDlg::OnPlayTime() 
{
	CTime theTime = CTime::GetCurrentTime();
	CString koe;
	koe += theTime.Format( "<NUMK VAL=%H COUNTER=じ>;" );
	koe += theTime.Format( "<NUMK VAL=%M COUNTER=ふん>;" );
	koe += theTime.Format( "<NUMK VAL=%S COUNTER=びょー>です。" );

	//音声合成＆再生
	SynthePlay(koe);
	
}

//! 羊が一匹、・・・
void CAqTkAppDlg::OnPlaySheep() 
{
	m_iSheep = 1;
	PlaySheep();
}

void CAqTkAppDlg::PlaySheep()
{
	CString koe;
	if(m_iSheep==14) koe.Format("ひつじの/メ'リーさん。");
	else if(m_iSheep==22) koe.Format("ひつじが/ころんだ。");
	else if(m_iSheep==27) koe.Format("ひつじが/いっぱい、");
	else if(m_iSheep==45) koe.Format("も'－;ねむく+なくな'ったよ、");
	else if(m_iSheep==65) koe.Format("し'つじの/セバ'_スチャン。");
	else				  koe.Format("ひつじが/<NUMK VAL=%d COUNTER=ひき>。", m_iSheep);
	m_iSheep++;

	//音声合成＆再生
	SynthePlay(koe, ID_SHEEP);
}

//! 任意文のメッセージを音声に変換してファイルに出力
void CAqTkAppDlg::OnSave() 
{
	CString koe;
	//数値文字列の取得
	((CEdit*)GetDlgItem(IDC_TEXT))->GetWindowText(koe);
	if(koe=="") return;

	// スライダの速度パラメータ取得
	CSliderCtrl *pScrollBar =(CSliderCtrl*)GetDlgItem(IDC_SPEED);
	int iSpeed = ((CSliderCtrl*)pScrollBar)->GetPos();

	// 音声波形をメモリ上に生成
	PrintLog("Synthe(\"%s\")\r\n", koe);
//	CAquesTalk aqtk;	// 規則音声合成エンジン（DAを含まない版）
	int size;			// 生成したwavデータのサイズ[byte]
//	aqtk.SetSpeed(fSpeed);	// 話速の設定
//	unsigned char *wav = aqtk.Synthe(koe, &size);
	unsigned char *wav = ::AquesTalk_Synthe(koe, iSpeed, &size);
	if(wav==0){ //err
		PrintLog("=>ERR:%d\r\n", size);
		return;
	}
	
	//出力ファイル名取得
	CFileDialog fileDlg(FALSE, _T("wav"), _T("*.wav"),OFN_HIDEREADONLY,
				_T("waveファイル(*.wav)|*.wav|全て(*.*)|*.*||") );
	if(fileDlg.DoModal()==IDOK) {
		//ファイルにsave
		FILE *fp;
		if((fp=fopen(fileDlg.GetPathName(), "wb"))!=0) {
			fwrite(wav, 1, size, fp);
			fclose(fp);
		}
		PrintLog("Saved to %s\r\n", fileDlg.GetPathName());
	}

	//音声波形バッファの解放
//	free(wav);
	::AquesTalk_FreeWave(wav);
}

void CAqTkAppDlg::OnOK() 
{
//	CDialog::OnOK();	//returnキーを無効とする
}


//! スライダの操作が行われた
void CAqTkAppDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	if(pScrollBar==GetDlgItem(IDC_SPEED)){
		m_iSpeed = ((CSliderCtrl*)pScrollBar)->GetPos();
	}
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}
